# Copyright 2017 The Nuclio Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import json


# JSON encoder that can encode custom stuff
class Encoder(json.JSONEncoder):
    def default(self, obj):

        # EAFP all the way. Leave the unused "exc" in for debugging ease
        try:
            return obj.__log__()
        except Exception as exc:  # noqa
            try:
                return obj.__repr__()
            except Exception as exc:  # noqa
                try:
                    return str(obj)
                except Exception as exc:
                    return "Unable to serialize object: {0}".format(exc)
